#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * "global" method (i.e. gets invoked on the root address xosd)
	 */

int getDaemons( ArrayListCA* returnValue);


	/**
	 * Retrieve the list of names of the services currently running on this
	 * daemon. 
	 * @return The list of names of the currently running services.
	 */

int getServiceList( ArrayList* returnValue);


	/**
	 * Send to the root the list of services running on this node.
	 * @return 0 if call was successful.
	 */

int registerMyServices( int* returnValue);




int getNodesRunningService(const char* __serviceName, ArrayListCA* returnValue);




int kill( int* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
