enum cda_client_error_codes {
 CDA_CLIENT_ERROR_AUTHENTICATING=-1,
 CDA_CLIENT_ERROR_OPENING_CDASERVER_CERTIFICATE=-2,
 CDA_CLIENT_ERROR_READING_CDASERVER_CERTIFICATE=-3,
 CDA_CLIENT_ERROR_CONNECTING_TO_SERVER=-4,
 CDA_CLIENT_ERROR_SSL_HANDSAKE=-5,
 CDA_CLIENT_ERROR_PEER_CERTIFICATE=-6, // peer certificate is invalid
 CDA_CLIENT_ERROR_IO=-7, // Input/Output error in connection with server, after
                         // successfull handsake.
 CDA_CLIENT_ERROR_OPENING_CDAROOT_CERTIFICATE=-8,
 CDA_CLIENT_ERROR_READING_CDAROOT_CERTIFICATE=-9,
 CDA_CLIENT_ERROR_VERIFING_CERT=-10,
 CDA_CLIENT_ERROR_ENTROPY=-11,
 CDA_CLIENT_ERROR_SERVER=-12, // server error: message error is in cdaserver_error
 CDA_CLIENT_ERROR_BAD_PROTOCOL=-13,
 CDA_CLIENT_ERROR_INTERNAL=-120
};

extern char *cdaserver_error;
int cda_client(char *hostname,
               int port,char *CDAcertfilename,
               char *RootCAcertfilename, char *username,
               char *password, char *voname,char **credential,
               char **certificate);

int cda_client_defergen(char *hostname,
               int port,char *CDAcertfilename,
               char *rootCAcertfilename, char *username,
               char *password, char *voname,char **credential,
               char **certificate);

int cda_client_nossl(char *hostname,int port,char *username,
                         char *password, char *voname, char **credential, 
                         char **certificate);

int cda_client_proxy(char *hostname,
               int port,char *Proxycertfilename,
               char *RootCAcertfilename, char *username,
               char *password, char *voname,char **credential,
               char **certificate);

int cda_client_proxy_nossl(char *hostname,int port,char *username,
                         char *password, char *voname, char **credential, 
                         char **certificate);


